' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2017                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Kubo
'
'  : 2017/9/7 
'
' Affine Sample Program
' -----------------------------------------------------------------



Public Class FormAffine


    '摜i[̈
    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()


    '摜i[̈(ʗp)
    Private m_dst As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()

    'rfI̓NX
    Private m_video As FVIL.Video.CFviVideo
 
    'ԌvNX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()

    'init@CݒtH[
    Public formBroseIni As Form_BROWSEINI = New Form_BROWSEINI()

    'init@CitpXj
    Public m_strIniFilePath As String
    'rfIfoCX̃I[v
    Private m_flgVideoOpened As Boolean
    'ԑp
    Dim msec As Double = 0



    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

    End Sub




    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown

        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageView1.Image = Me.m_image


    End Sub



    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                '摜TCY
                m_video.ChangeImageSize(m_image)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Value = m_video.ExposureTime
           
                End If

                btnGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            btnGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    Private Sub btnGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrabOne.Click
        Try
            formBroseIni.UseFileFlg = False

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try




    End Sub


    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub


    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub


    ''' <summary>
    ''' LoadFile {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͉摜t@C̃[hB
    ''' </remarks>
    Private Sub btnLoadImageFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImageFile.Click
        Form_BROWSEINI.UseFileFlg = True
        '͉摜t@C̃[h
        openFileDialog1.FileName = ""
        openFileDialog1.Filter = "Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        openFileDialog1.Filter += "|Png t@C (*.png)|*.png"
        openFileDialog1.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        openFileDialog1.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        openFileDialog1.DefaultExt = "*.bmp"
        If ((openFileDialog1.FileNames.Length <= 0) Or (openFileDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.Cancel)) Then
            Return
        End If

        Try
            FVIL.File.Function.LoadImageFile(openFileDialog1.FileName, m_image, FVIL.PixelMode.Unpacking)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub


    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub btnMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click

        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub btnFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click

        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub btnPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub btnMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub



    ''' <summary>
    ''' sړ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' w肳ꂽړʂŕsړ摜\܂B
    ''' </remarks>
    Private Sub btnShift_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShift.Click

        'sړ
        Dim dlgSift As FormSift = New FormSift

        m_image.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)
        m_dst.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)

        Try
            If (dlgSift.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then

                Dim sift As FVIL.GeoTrans.CFviShift = New FVIL.GeoTrans.CFviShift()

                sift.SrcImages(0) = m_image
                sift.DstImages(0) = m_dst

                sift.ShiftX = dlgSift.MoveX
                sift.ShiftY = dlgSift.MoveY

                sift.Execute()

                '`imagẽZbg
                CFviImageView1.Image = m_dst
                'ĕ`
                CFviImageView1.Refresh()

            End If

        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub



    ''' <summary>
    ''' ]{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' w肵pxŉ摜]܂B
    ''' </remarks>
    Private Sub btnRotate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRotate.Click

        ']
        Dim dlgRotate As FormRotate = New FormRotate

        m_image.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)
        m_dst.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)

        Dim rotate As FVIL.GeoTrans.CFviRotate = New FVIL.GeoTrans.CFviRotate()
        Dim pos As FVIL.Data.CFviPoint = New FVIL.Data.CFviPoint()

        If (dlgRotate.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then


            Try

                If 0 <> dlgRotate.dAngle Or 0 > dlgRotate.dAngle Then

                    rotate.SrcImages(0) = m_image
                    rotate.DstImages(0) = m_dst

                    '摜̒S]SƂĐݒ
                    pos.X = m_image.HorzSize / 2.0
                    pos.Y = m_image.VertSize / 2.0

                    rotate.Axis = pos
                    rotate.Angle = New FVIL.Data.CFviAngle(dlgRotate.dAngle)

                    rotate.Execute()
                Else
                    ' 90xNx̏ꍇ́ACFviImageGetRotatedImageł]ł܂B
                    '(0:0 xA1:90 xA2:180 xA3:270 x)
                    m_dst = m_image.GetRotatedImage(dlgRotate.dAngle / 90)

                End If


            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try



            '`imagẽZbg
            CFviImageView1.Image = m_dst
        End If


        'ĕ`
        CFviImageView1.Refresh()



    End Sub


    ''' <summary>
    ''' g{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜2{Ɋg債AViewɕ\܂B
    ''' </remarks>
    Private Sub btnEnlarge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnlarge.Click

        m_image.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)
        m_dst.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)
        Dim scale As FVIL.GeoTrans.CFviScale = New FVIL.GeoTrans.CFviScale()

        Try

            scale.SrcImages(0) = m_image
            scale.DstImages(0) = m_dst

            scale.MagnificationOfHorz = 2.0
            scale.MagnificationOfVert = 2.0


            scale.Execute()

        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        '`imagẽZbg
        CFviImageView1.Image = m_dst
        'ĕ`
        CFviImageView1.Refresh()

    End Sub



    ''' <summary>
    ''' k{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜1/2ɏkAViewɕ\܂B
    ''' </remarks>
    Private Sub btnReduction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReduction.Click



        Dim scale As FVIL.GeoTrans.CFviScale = New FVIL.GeoTrans.CFviScale()
        m_image.Window = New Rectangle(0, 0, m_image.HorzSize, m_image.VertSize)

        scale.SrcImages(0) = m_image
        scale.DstImages(0) = m_dst

        scale.MagnificationOfHorz = 0.5
        scale.MagnificationOfVert = 0.5

        Try
            '
            scale.DstImages(0).Window = New Rectangle(0, 0, m_image.HorzSize / 2, m_image.VertSize / 2)
            scale.Execute()

            'E
            scale.DstImages(0).Window = New Rectangle(m_image.HorzSize / 2, 0, m_image.HorzSize / 2, m_image.VertSize / 2)
            scale.Execute()

            ' 
            scale.DstImages(0).Window = New Rectangle(0, m_image.VertSize / 2, m_image.HorzSize / 2, m_image.VertSize / 2)
            scale.Execute()

            ' E
            scale.DstImages(0).Window = New Rectangle(m_image.HorzSize / 2, m_image.VertSize / 2, m_image.HorzSize / 2, m_image.VertSize / 2)
            scale.Execute()

        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        '`imagẽZbg
        CFviImageView1.Image = m_dst
        'ĕ`
        CFviImageView1.Refresh()


    End Sub

    Private Sub btnAreaEnlarge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAreaEnlarge.Click
        Try

            If (CFviImageView1.Display.OverlayProcarea.Active) Then

                CFviImageView1.Display.OverlayProcarea.Active = False

                Dim scale As FVIL.GeoTrans.CFviScale = New FVIL.GeoTrans.CFviScale()

                '2{Ɋg
                scale.SrcImages(0) = m_image
                scale.DstImages(0) = m_dst

                'g̔{vZ
                Dim dblScaleX As Double = CType(m_image.ImageSize.HorzSize, Double) / CType(m_image.Window.Width, Double)
                Dim dblScaleY As Double = CType(m_image.ImageSize.VertSize, Double) / CType(m_image.Window.Height, Double)

                scale.MagnificationOfHorz = dblScaleX
                scale.MagnificationOfVert = dblScaleY

                'gs
                scale.Execute()


                btnAreaEnlarge.Text = "̈w肵Ċg"
                btnEnlarge.Enabled = True

                If (Form_BROWSEINI.UseFileFlg = False) Then
                    btnGrabOne.Enabled = True
                End If

                ' ύX{^ɖ߂
                btnLoadImageFile.Enabled = True
                btnReduction.Enabled = True
                btnShift.Enabled = True
                btnRotate.Enabled = True


                '`imagẽZbg
                CFviImageView1.Image = m_dst
                'ĕ`
                CFviImageView1.Refresh()


            Else '̈wp@@͈͂`
                '̈炩ߐݒ
                m_image.Window = New Rectangle(m_image.VertSize / 3, m_image.HorzSize / 3, m_image.VertSize / 3, m_image.HorzSize / 3)
                m_dst.SetSize(m_image.ImageSize.ToSize(), m_image.ImageType, m_image.Channel)

                '̈wpɏ͈͂`
                CFviImageView1.Display.OverlayProcarea.Active = True

                '`imagẽZbg
                CFviImageView1.Image = m_image
                'ĕ`
                CFviImageView1.Refresh()


                '̈w蒆ɑ̏słȂ悤ɕύX
                btnAreaEnlarge.Text = "̈w芮"
                btnEnlarge.Enabled = False
                btnGrabOne.Enabled = False
                btnLoadImageFile.Enabled = False
                btnReduction.Enabled = False
                btnShift.Enabled = False
                btnRotate.Enabled = False

            End If


        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try


    End Sub
End Class
